/*
 * Copyright 2013-2018 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.verilog.parser.walker;

import ru.ispras.verilog.parser.core.TreeWalker;
import ru.ispras.verilog.parser.model.VerilogNode;

/**
 * {@link VerilogTreeWalker} implements a walker that traverses an abstract syntax tree.
 * 
 * @author <a href="mailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class VerilogTreeWalker extends TreeWalker<VerilogNode.Tag> {

  /**
   * Creates a Verilog tree walker.
   * 
   * @param root the root of the Verilog tree to be traversed.
   * @param visitor the user-defined visitor of Verilog tree nodes.
   */
  public VerilogTreeWalker(final VerilogNode root, final VerilogNodeVisitor visitor) {
    super(root, visitor);
  }
}
